package cs636.pizza.dao;
// See https://www.baeldung.com/spring-data-derived-queries
import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;
import cs636.pizza.domain.PizzaOrder;

@Repository
public interface PizzaOrderRepository extends JpaRepository<PizzaOrder, Integer> {
	// custom-made finders: do what their name says
	// They attach a PizzaSize to each PizzaOrder, but leave the Set<Toppings> off
	// for lazy loading in service layer code if needed
	List<PizzaOrder> findByRoomNumberAndDay(int room, int day);
	List<PizzaOrder> findByDayBetween(int day1, int day2);
	// use first on list for findFirstOrder
	List<PizzaOrder> findByStatusOrderById(int status);
	//save(PizzaOrder)  gen'd automatically, same as insertOrder.
}
